C********************************************************************C
C                                                                    C
C     THIS INCLUDE FILE GIVES PHYSICAL CONSTANTS                     C
C     FOR CALCULATIONS WITHIN STANDARD MODEL                         C
C                                                                    C
C     Note:                                                          C
C     - f77 is not case sensitive, but all these "GLOBAL" parameters C
C       are defined uppercase for easier use                         C
C                                                                    C
C     19.08.97 m.h.                                                  C
C                                                                    C
C1.0 === Currently it includes the following definitions ===         C
C                                                                    C
C      SM_MW = 80.41D0                     ! m(W)                    C
C      SM_GAW=2.06D0                        ! \Gamma(W)              C
C      SM_MZ = 91.187D0                    ! m(Z)                    C
C      SM_GAZ=2.490D0                       ! \Gamma(Z)              C
C      SM_EMASS=0.510999007D-03            ! m(e)                    C
C      SM_MUMASS=1.05658389D-01            ! m(\mu)                  C
C      SM_TAUMASS=1.7771D0                 ! m(\tau)                 C
C                                                                    C
C      SM_ALPHA=1.0D0/137.0359895D0         ! Fine structure constantC
C      SM_ALPHAZ=1.0D0/127.9D0              ! \alpha at m(Z)         C
C      SM_S2TW= 0.2319D0                    ! Sin^2(\theta_W)        C
C      SM_HBARC=0.197327053D0               ! hbar * c in [GeV*fm]   C
C                                                                    C
C      Added on Wed Feb  3, 1999:                                    C
C      SM_GFERMI=1.16639D-05                ! [GeV^(-2)]             C
C                                                                    C
C********************************************************************C
      DOUBLE PRECISION SM_MW,SM_GAW,SM_MZ,SM_GAZ
      DOUBLE PRECISION SM_EMASS,SM_MUMASS,SM_TAUMASS
      DOUBLE PRECISION SM_TOPMASS,SM_CHARMMASS,SM_UPMASS
      DOUBLE PRECISION SM_DOWNMASS,SM_STRANGEMASS,SM_BOTTOMMASSZ
      DOUBLE PRECISION SM_ALPHA,SM_ALPHAZ,SM_S2TW
      DOUBLE PRECISION SM_HBARC
      DOUBLE PRECISION SM_GFERMI

      PARAMETER(
     +          SM_MW = 80.41D0,
     +          SM_GAW = 2.06D0,
     +          SM_MZ = 91.187D0,
     +          SM_GAZ = 2.490D0,
     +          SM_EMASS = 0.510999007D-03,
     +          SM_MUMASS = 1.05658389D-01,
     +          SM_TAUMASS = 1.7771D0,
     +          SM_TOPMASS = 173.8D0,              ! Romao
     +          SM_CHARMMASS = 1.4D0,              ! Romao
     +          SM_UPMASS = 0.004D0,              ! Romao
     +          SM_DOWNMASS = 0.008D0,              ! Romao
     +          SM_STRANGEMASS = 0.100D0,              ! Romao
     +          SM_BOTTOMMASSZ = 3.0D0,              ! mb(M_Z)
     +          SM_ALPHA = 1.0D0/137.0359895D0,
     +          SM_ALPHAZ = 1.0D0/127.9D0, 
     +          SM_S2TW = 0.2319D0, 
     +          SM_HBARC = 0.197327053D0,
     +          SM_GFERMI =  1.16639D-05)












